<?php

/**
 * This project has been generated by worker generator
 * has been made by fahmi sulaiman
 * sulaimanfahmi@gmail.com
 * check out my github @dekaulitz
 */

namespace App\Http\Controllers\Administrator;

use App\Exceptions\DefaultException;
use App\Http\Base\BaseController;
use Illuminate\Http\Request;
use Illuminate\Support\Facades\DB;
use App\Http\Services\SystemparameterService;
use App\Http\Validators\SystemparameterValidator;
use App\Http\Services\ActivitylogService;

class SystemparameterController extends BaseController
{
    protected $baseService;
    protected $validator;
    private $activityLog;

    /**
     * Systemparameter constructor.
     */
    public function __construct()
    {
        parent::__construct();
        $this->baseService = new SystemparameterService();
        $this->validator = new SystemparameterValidator();
        $this->activityLog = new ActivitylogService();
    }


    /**
     * @param Request $request
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function store(Request $request)
    {
        $this->validator->beforeInsert($request->all());
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $ID = $this->baseService->store($request->all());

            $auth = json_decode($request->session()->get('auth'));
            $activityLog = [
                "username" => $auth->username,
                "urlTransaksi" => "systemparameter",
                "namaTransaksi" => "System Parameters",
                "date" => date("Y-m-d H:i:s"),
                "activity" => "CREATE",
                "refId" => $ID,
                "date_updated" => date("Y-m-d H:i:s"),
                "kapalId" => $auth->kapalId,
                "deskripsi" => $auth->name . " just <b>created</b> new System Parameter <a href=\"" . url("administrator/systemparameter/" . $ID) . "\">here</a>"
            ];
            $this->activityLog->store($activityLog);

            DB::commit();
            $this->sync();
            return redirect()->to("administrator/systemparameter")->with("successMessages", "Data has been created");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @param Request $request
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function paging(Request $request)
    {
        $this->data["header"] = [
            "id" => "ID", "variableName" => "Variable Name", "variableValue" => "Variable Value"
        ];
        $this->data["criteria"] = [
            "id" => "ID", "variableName" => "Variable Name", "variableValue" => "Variable Value"
        ];
        $this->data["ordering"] = [
            "variableName:asc" => "Variable Name &uarr;", "variableName:desc" => "Variable Name &darr;", "variableValue:asc" => "Variable Value &uarr;", "variableValue:desc" => "Variable Value &darr;"
        ];
        $this->data["systemparameters"] = $this->baseService->paging($request->all());

        return view("modules.systemparameter.systemparameter_index", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function edit(Request $request, $id)
    {
        $auth = json_decode($request->session()->get('auth'));
        if ($auth->aplikasi == "HO") {
            $id = intval($id);
            if ($id > 0) {
                $this->data["systemparameter"] = $this->baseService->show($id);
                if ($this->data["systemparameter"]) {
                    return view("modules.systemparameter.systemparameter_edit", $this->data);
                } else {
                    return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
                }
            } else {
                return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
            }
        } else {
            return redirect()->to("administrator/systemparameters")->with("errMessage", "Sorry, you don't have access to this page!");
        }
    }


    /**
     * @param Request $request
     * @param $id
     * @return \Illuminate\Http\RedirectResponse
     * @throws DefaultException
     */
    public function update(Request $request, $id)
    {
        $this->validator->beforeUpdate($request->all(), $id);
        if ($this->validator->hasError())
            return $this->validator->validateView();
        DB::beginTransaction();
        try {
            $this->baseService->update($id, $request->all());

            $auth = json_decode($request->session()->get('auth'));
            $activityLog = [
                "username" => $auth->username,
                "urlTransaksi" => "systemparameter",
                "namaTransaksi" => "System Parameters",
                "date" => date("Y-m-d H:i:s"),
                "activity" => "UPDATE",
                "refId" => $id,
                "date_updated" => date("Y-m-d H:i:s"),
                "kapalId" => $auth->kapalId,
                "deskripsi" => $auth->name . " just <b>updated</b> System Parameter <a href=\"" . url("administrator/systemparameter/" . $id) . "\">here</a>"
            ];
            $this->activityLog->store($activityLog);


            DB::commit();
            $this->sync();
            return redirect()->to("administrator/systemparameter")->with("successMessages", "Data has been updated");
        } catch (\Exception $e) {
            DB::rollBack();
            throw new DefaultException($e->getMessage());
        }
    }

    /**
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function create()
    {
        return view("modules.systemparameter.systemparameter_create", $this->data);
    }

    /**
     * @param $id
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function show($id)
    {
        $id = intval($id);
        if ($id > 0) {
            $this->data["systemparameter"] = $this->baseService->show($id);
            if ($this->data["systemparameter"]) {
                return view("modules.systemparameter.systemparameter_show", $this->data);
            } else {
                return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
            }
        } else {
            return redirect()->back()->with("errMessage", "No data found. Please check this with your Administrator/Nahkoda.");
        }
    }

    /**
     *  index function that get all data from database by default
     * @param $ids
     * @return \Illuminate\Contracts\View\Factory|\Illuminate\View\View
     */
    public function destroy($ids)
    {
        $this->baseService->delete($ids);
        return redirect()->back()->with("successMessages", "Data has been deleted");
    }
}
